/************************************************************************/
/*		aPCI-8375 Device Driver for Windows 9x/NT						*/
/*																		*/
/*			apci8375.h		-	Win32 interface definition				*/
/*			date			-	1999/10/21								*/
/************************************************************************/

#if !defined( APCI8375_H )
#define	APCI8375_H

#ifdef	__cplusplus
extern	"C" {
#endif

/*==================*/
/*	Error Code		*/
/*==================*/
#define	APCI8375_SUCCESS				0	/* Successfully proccessed */
#define	APCI8375_ERR_SYSTEM				1	/* Call GetLastError() */
#define	APCI8375_ERR_NO_DEVICE			2	/* No card */
#define	APCI8375_ERR_IN_USE				3	/* Device is in use */
#define	APCI8375_ERR_INVALID_BSN		4	/* Invalid board select number */
#define	APCI8375_ERR_RESOURCE			5	/* Resource exhaustion */
#define	APCI8375_ERR_INVALID_VALUE		6	/* Invalid value */
#define	APCI8375_ERR_INVALID_ARGUMENT	7	/* Invalid argument */
#define	APCI8375_ERR_NO_CREATE			8	/* No created device */
#define APCI8375_ERR_TIMEOUT			9	/* Time out error */
#define	APCI8375_ERR_BANK_NOT_0			10	/* BANK is not zero */
#define	APCI8375_ERR_INVALID_SLOT		21	/* Invalid slot number(used by DLL) */


/*==================*/
/*	Miscellaneous	*/
/*==================*/
#define	APCI8375_MAX_SLOTS		32		/* Maximum number of slots */
#define APCI8375_MAX_PORTS		32		/* Maximum number of user ports */

										/* default search */
#define	APCI8375_BSN_AUTO		( ( WORD ) ~0U )
										/* default search(used by DLL) */
#define	APCI8375_SLOT_AUTO		( ( WORD ) ~0U )

#define	APCI8375_BSN_PORT		0x20	/* BSN port address */

/*==============*/
/*	Device ID	*/
/*==============*/
#define	APCI8375_BOARD_ID	0x8175		/* pci bus device id */
#define	APCI8375_VENDOR_ID	0x136c		/* pci bus vendor id */
										/* our device id */
#define	APCI8375_DEVICE_ID	( ( DWORD )APCI8375_BOARD_ID\
							| ( ( DWORD )APCI8375_VENDOR_ID << 16 ) )

#if !defined( APCI8375_DRIVER )
#define	APCI8375_API

#if !defined( APCI8375_DLL )
	#define APCI8375LIB_API	extern __declspec( dllimport )
#else
	#define APCI8375LIB_API	extern __declspec( dllexport )
#endif

#ifdef _BORLANDC_
	#define EXPVAR			__pascal
#else
	#define	EXPVAR
#endif

/*======================================*/
/*	An action after writing a data		*/
/*  to data area of SL-PCI board(s).	*/
/*	We use following definitions in		*/
/*	Apci8375OutBit and Apci8375OutByte.		*/
/*======================================*/
#define APCI8375_NO_ACTION        0		/* return with no action */
#define APCI8375_ACT_FRAME_CHECK  1		/* return after checking completion of transfer */
#define APCI8375_ACT_WAIT         2		/* return after wasting 100msec */

/*==================*/
/*	API Functions	*/
/*==================*/

APCI8375LIB_API BOOL  WINAPI	Apci8375GetVersion( PDWORD pdwDllVersion, PDWORD pdwDriverVersion );
APCI8375LIB_API BOOL  WINAPI	Apci8375Create( PWORD pwBsn );
APCI8375LIB_API BOOL  WINAPI	Apci8375SetWaitTime( WORD wBsn,DWORD dwWaitTime );
APCI8375LIB_API BOOL  WINAPI	Apci8375SetIOs( WORD wBsn, DWORD dwIOs );
APCI8375LIB_API BOOL  WINAPI	Apci8375GetIOs( WORD wBsn, PDWORD pdwIOs );
APCI8375LIB_API BOOL  WINAPI	Apci8375SystemSet( WORD wBsn );
APCI8375LIB_API BOOL  WINAPI	Apci8375GetTotalUnitNumber( WORD wBsn, PDWORD pdwUnits, PBOOL pComplete );
APCI8375LIB_API BOOL  WINAPI	Apci8375SystemAddressLength( WORD wBsn, PDWORD pdwLength );
APCI8375LIB_API BOOL  WINAPI	Apci8375InBit( WORD wBsn, DWORD dwSlAddress, PBOOL pStatus );
APCI8375LIB_API BOOL  WINAPI	Apci8375OutBit( WORD wBsn, DWORD dwSlAddress, BOOL Status, DWORD dwAction );
APCI8375LIB_API BOOL  WINAPI	Apci8375InByte( WORD wBsn, DWORD dwSlAddress, PDWORD pdwData );
APCI8375LIB_API BOOL  WINAPI	Apci8375OutByte( WORD wBsn, DWORD dwSlAddress, DWORD dwData, DWORD dwAction );
APCI8375LIB_API BOOL  WINAPI	Apci8375Close( WORD wBsn );
APCI8375LIB_API BOOL  WINAPI	Apci8375GetErrorFlags( WORD wBsn, PDWORD pdwFlags, PDWORD pdwERR4Units );
APCI8375LIB_API BOOL  WINAPI	Apci8375ReadStatusArea( WORD wBsn, DWORD dwLogPort, PDWORD pdwData );
APCI8375LIB_API BOOL  WINAPI	Apci8375WriteStatusArea( WORD wBsn, DWORD dwLogPort, DWORD dwData );
APCI8375LIB_API BOOL  WINAPI	Apci8375GetBS1AStatus( WORD wBsn, DWORD dwAddress, PBOOL pConnected, PBOOL pActive );
APCI8375LIB_API BOOL  WINAPI	Apci8375GetCommStatus( WORD wBsn, PBOOL pStatus );
APCI8375LIB_API BOOL  WINAPI	Apci8375BankChange( WORD wBsn, DWORD dwBank );
APCI8375LIB_API DWORD WINAPI	Apci8375GetLastError( WORD wBsn );

#endif	/* #if !defined( APCI8375_DRIVER ) */

#ifdef	__cplusplus
}
#endif

#endif	/* #if !defined( APCI8375_H ) */

/**/