/*============================================================================
//	apci8375s.c
//
//	aPCI-8375
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.00 Date 1999/10/21
//
//	Tv
//		̿ɂׯ߰֐̎gpႪLqĂ܂B
//		aPCI-8375{[h̐ݒ͈ȉ̂悤ȐݒƂ܂B
//			EVXeAhX32_
//			EI/OݒXCb`͑SONíj
//		ڑjbg̐ݒ
//			Eo̓jbgi16_j̐擪AhX 0h Ƃ܂B
//			E̓jbgi16_j̐擪AhX 10h Ƃ܂B
//
//==========================================================================*/
#define	STRICT
#include <windows.h>
#include <tchar.h>
#include "apci8375w.h"

const TCHAR szTitle[]	= _T("Sample");
const TCHAR szSLPCI[]	= _T("aPCI-8375");
#define	WAIT_TIME		200L
#define	SET_IOS			0x01

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wBsn);

/*============================================================================
//	۸т̊Jn
//==========================================================================*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	WORD	wBsn;				/* ޲BSNi[ */
	DWORD	dwDLLVer, dwDriverVer;
	TCHAR	szBuf[1024];
	DWORD	dwFlags, dwERR4Units;
	DWORD	dwUnits;
	BOOL	Complete;
	DWORD	dwLength;
	DWORD	dwIOs;
	DWORD	dwSlAddress, dwData;
	BOOL	Connected, Active;
	BOOL	Status;

	/*-------------------------------------------------
	// apci8375.dll ̎gp錾
	//-----------------------------------------------*/
	if (Apci8375wDllOpen() == FALSE){
		ErrorMessage(APCI8375_BSN_AUTO);
		return 1;					/* apci8375.dll ۰ނɎs܂ */
	}
	/*-------------------------------------------------
	// ްޮݔԍ\
	// aPCI-8375 DLL,ײްްޮݔԍ擾
	//-----------------------------------------------*/
	if (Apci8375wGetVersion(&dwDLLVer, &dwDriverVer) == FALSE){
		ErrorMessage(APCI8375_BSN_AUTO);
		return 1;
	}
	wsprintf(szBuf, _T("GetVersion\n")
					_T("DLL Version\t: %08xH\n")
					_T("Driver Version\t: %08xH")
					,dwDLLVer, dwDriverVer);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// aPCI-8375̎gp錾
	//-----------------------------------------------*/
	wBsn = APCI8375_BSN_AUTO;				/* gp޲T܂B*/
	if (Apci8375wCreate(&wBsn) == FALSE){	/* ꍇA̎޲BSNi[܂B*/
		ErrorMessage(APCI8375_BSN_AUTO);	/* ޲܂B*/
		return 1;
	}
	wsprintf(szBuf, _T("aPCI-8375 Created\n\nBoard Select No.: %02XH"), wBsn);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// aPCI-8375̼Ѿ
	//-----------------------------------------------*/
	if (Apci8375wSystemSet(wBsn) == FALSE){
		ErrorMessage(wBsn);
		return 1;
	}
	ResultMessage(_T("System Set"));
	/*-------------------------------------------------
	// aPCI-8375̏Ԏ擾
	//-----------------------------------------------*/
	if (Apci8375wGetErrorFlags(wBsn, &dwFlags, &dwERR4Units) == FALSE){
		ErrorMessage(wBsn);
		return 1;
	}
	if (Apci8375wGetTotalUnitNumber(wBsn, &dwUnits, &Complete) == FALSE){
		ErrorMessage(wBsn);
		return 1;
	}
	if (Apci8375wSystemAddressLength(wBsn, &dwLength) == FALSE){
		ErrorMessage(wBsn);
		return 1;
	}
	wsprintf(szBuf, _T("Board Name\t: %s\n")
					_T("Error Flags\t: %02XH\n")
					_T("ER4 Units\t\t: %2d\n")
					_T("Total Unit Number\t: %2d\n")
					_T("System Address Length: %d")
					, szSLPCI, dwFlags, dwERR4Units
					, dwUnits, dwLength);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// aPCI-8375̒ʐM
	//-----------------------------------------------*/
	if (Apci8375wGetCommStatus(wBsn, &Status) == FALSE){
		ErrorMessage(wBsn);
		return 1;
	}
	if (Status == TRUE)
		strcpy(szBuf, _T("Com. Status : GOOD"));
	else
		strcpy(szBuf, _T("Com. Status : BAD"));

	ResultMessage(szBuf);
	/*-------------------------------------------------
	// BS1A
	//-----------------------------------------------*/
	strcpy(szBuf, _T("BS1A Status\n"));
	for (dwSlAddress = 0; dwSlAddress <= 6; dwSlAddress++){
		if (Apci8375wGetBS1AStatus(wBsn, dwSlAddress, &Connected, &Active) == FALSE){
			ErrorMessage(wBsn);
			return 1;
		}
		wsprintf(szBuf, _T("%sAddress %d: "), szBuf, dwSlAddress);
		if (Connected == TRUE)
			wsprintf(szBuf, _T("%sConnection=ON  "), szBuf);
		else
			wsprintf(szBuf, _T("%sConnection=OFF "), szBuf);

		if (Active == TRUE)
			wsprintf(szBuf, _T("%sActive=GOOD \n"), szBuf);
		else
			wsprintf(szBuf, _T("%sActive=BAD  \n"), szBuf);

	}
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// aPCI-8375̏ݒ
	//-----------------------------------------------*/
	if (Apci8375wSetWaitTime(wBsn, WAIT_TIME) == FALSE){
		ErrorMessage(wBsn);
		return 1;
	}
	if (Apci8375wSetIOs(wBsn, SET_IOS) == FALSE){
		ErrorMessage(wBsn);
		return 1;
	}
	if (Apci8375wGetIOs(wBsn, &dwIOs) == FALSE){
		ErrorMessage(wBsn);
		return 1;
	}
	if (Apci8375wBankChange(wBsn, 0) == FALSE){
		ErrorMessage(wBsn);
		return 1;
	}
	wsprintf(szBuf, _T("Set Wait Time: %dms\n")
					_T("Set IOs\t: %2XH\n")
					_T("Get IOs\t: %2XH\n")
					_T("Bank\t: 0")
					, WAIT_TIME, SET_IOS, dwIOs );
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// S-LINKAhX 0 ` 15 SON
	//-----------------------------------------------*/
	for (dwSlAddress = 0; dwSlAddress <= 15; dwSlAddress++){
		if (Apci8375wOutBit(wBsn, dwSlAddress, TRUE, APCI8375_ACT_FRAME_CHECK) == FALSE){
			ErrorMessage(wBsn);
			return 1;
		}
	}
	ResultMessage(_T("S-LINK Address 0 - 15 All ON"));
	/*-------------------------------------------------
	// S-LINKAhX 0 ` 31 ǂݏo
	//-----------------------------------------------*/
	strcpy(szBuf, _T("S-LINK Address 0 - 31 I/O\n"));
	for (dwSlAddress = 0; dwSlAddress <= 31; dwSlAddress++){
		if (Apci8375wInBit(wBsn, dwSlAddress, &Status) == FALSE){
			ErrorMessage(wBsn);
			return 1;
		}
		if (TRUE == Status)
			wsprintf(szBuf, _T("%sAddress %2d\t: ON\n"), szBuf, dwSlAddress );
		else
			wsprintf(szBuf, _T("%sAddress %2d\t: OFF\n"), szBuf, dwSlAddress );
	}

	ResultMessage(szBuf);
	/*-------------------------------------------------
	// S-LINK޲ıڽ 0 ` 1 SOFF
	//-----------------------------------------------*/
	for (dwSlAddress = 0; dwSlAddress <= 1; dwSlAddress++){
		if (Apci8375wOutByte(wBsn, dwSlAddress, 0, APCI8375_ACT_FRAME_CHECK) == FALSE){
			ErrorMessage(wBsn);
			return 1;
		}
	}
	ResultMessage(_T("S-LINK Byte Address 0 - 1 All OFF"));
	/*-------------------------------------------------
	// S-LINK޲ıڽ 0 ` 3 ǂݏo
	//-----------------------------------------------*/
	strcpy(szBuf, _T("S-LINK Byte Address 0 - 3 I/O\n"));
	for (dwSlAddress = 0; dwSlAddress <= 3; dwSlAddress++){
		if (Apci8375wInByte(wBsn, dwSlAddress, &dwData) == FALSE){
			ErrorMessage(wBsn);
			return 1;
		}
		wsprintf(szBuf, _T("%sByte Address %2d\t: %2XH\n"), szBuf, dwSlAddress, dwData);
	}
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// aPCI-8375Bank2
	//(Apci8375wReadStatusArea, Apci8375wWriteStatusAreaݸ؂ւƓ)
	//-----------------------------------------------*/
	if (Apci8375wWriteStatusArea(wBsn, 0x14, 2) == FALSE){
		ErrorMessage(wBsn);
		return 1;
	}
	do {
		if (Apci8375wReadStatusArea(wBsn, 0x15, &dwData) == FALSE){
			ErrorMessage(wBsn);
			return 1;
		}
	} while(dwData != 2);
	strcpy(szBuf, _T("Bank2 : \n"));
	for (dwSlAddress = 0; dwSlAddress <= 3; dwSlAddress++){
		if (Apci8375wInByte(wBsn, dwSlAddress, &dwData) == FALSE){
			ErrorMessage(wBsn);
			return 1;
		}
		wsprintf(szBuf, _T("%sByte Address %2d\t: %2XH\n"), szBuf, dwSlAddress, dwData);
	}
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// aPCI-8375̎gpJ
	//-----------------------------------------------*/
	if (Apci8375wClose(wBsn) == FALSE){
		ErrorMessage(wBsn);
		return 1;
	}
	ResultMessage(_T("aPCI-8375 Closed"));
	/*-------------------------------------------------
	// apci8375.dll ̎gpJ
	//-----------------------------------------------*/
	if (Apci8375wDllClose() == FALSE){
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;
	}
	return 1;
}

/*============================================================================
// ʂ\
//==========================================================================*/
static void ResultMessage(LPCTSTR lpszBuf)
{
	MessageBox(NULL, lpszBuf, szTitle, MB_OK | MB_ICONINFORMATION);
}
/*============================================================================
// װүނ\
//==========================================================================*/
static void ErrorMessage(WORD wBsn)
{
	DWORD dwRes = Apci8375wGetLastError(wBsn);
	TCHAR szBuf[50];

	switch (dwRes){
		case APCI8375_ERR_SYSTEM:
			wsprintf(szBuf, _T("System error\n\n")
							_T("Error code: %08lXH"),
							GetLastError());
			break;
		case APCI8375_ERR_WRAPDLL:
			wsprintf(szBuf, _T("DLL Load error"));
			break;
		default:
			wsprintf(szBuf, _T("aPCI-8375 error\n\n")
							_T("Error code: %08lXH"),
							dwRes);
			break;
	}
	MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
}
